LOCAL_PATH := $(call my-dir)
include $(CLEAR_VARS)

GST_RTSP_SERVER_TOP := $(LOCAL_PATH)

GST_RTSP_SERVER_BUILT_SOURCES := 						\
	pkgconfig/gst-rtsp-server.pc				\
	pkgconfig/gst-rtsp-server-uninstalled.pc.pc	        \
	gst/rtsp-server/Android.mk		
	



GST_RTSP_SERVER_BUILT_SOURCES := $(patsubst %, $(abspath $(GST_RTSP_SERVER_TOP))/%, $(GST_RTSP_SERVER_BUILT_SOURCES))


.PHONY: gst-rtsp-server-configure
gst-rtsp-server-configure:
	cd $(GST_RTSP_SERVER_TOP) ; \
	CC="$(CONFIGURE_CC)" \
	CFLAGS="$(CONFIGURE_CFLAGS)" \
	LD=$(TARGET_LD) \
	LDFLAGS="$(CONFIGURE_LDFLAGS)" \
	CPP=$(CONFIGURE_CPP) \
	CPPFLAGS="$(CONFIGURE_CPPFLAGS)" \
	PKG_CONFIG_LIBDIR="$(CONFIGURE_PKG_CONFIG_LIBDIR)" \
	PKG_CONFIG_TOP_BUILD_DIR=/ \
	IVORBIS_CFLAGS="-I$(TOP)/external/tremolo -DTREMOR" \
	IVORBIS_LIBS="-lvorbisidec" \
	$(abspath $(GST_RTSP_SERVER_TOP))/$(CONFIGURE) --host=arm-linux-androideabi \
	--prefix=/system --disable-orc --disable-gio --enable-ivorbis \
	--disable-valgrind --disable-gtk-doc && \
	for file in $(GST_RTSP_SERVER_BUILT_SOURCES); do \
		rm -f $$file && \
		make -C $$(dirname $$file) $$(basename $$file) ; \
	done

CONFIGURE_TARGETS += gst-rtsp-server-configure

-include $(GST_RTSP_SERVER_TOP)/gst/rtsp-server/Android.mk


